# eric6.Debugger.StartDialog

Module implementing the Start Program dialog.

### Global Attributes

None

### Classes

StartDialog | Class implementing the Start Program dialog.

### Functions

None

## StartDialog

Class implementing the Start Program dialog.

It implements a dialog that is used to start an application for debugging. It asks the user to enter the commandline parameters, the working directory and whether exception reporting should be disabled.

### Derived from

QDialog

### Class Attributes

None

### Class Methods

None

### Methods

StartDialog | Constructor
__clearHistories | Private slot to clear the combo boxes lists and record a flag to clear the lists.
__editHistory | Private slot to edit a history list.
clearHistories | Public method to test, if histories shall be cleared.
getCoverageData | Public method to retrieve the coverage related data entered into this dialog.
getData | Public method to retrieve the data entered into this dialog.
getDebugData | Public method to retrieve the debug related data entered into this dialog.
getHistories | Public method to get the lists of histories.
getProfilingData | Public method to retrieve the profiling related data entered into this dialog.
getRunData | Public method to retrieve the debug related data entered into this dialog.
historiesModified | Public method to test for modified histories.
on_buttonBox_clicked | Private slot called by a button of the button box clicked.
on_modFuncCombo_editTextChanged | Private slot to enable/disable the OK button.

### Static Methods

None

#### StartDialog (Constructor)

StartDialog(caption, interpreterList, argvList, wdList, envList, exceptions, parent=None, dialogType=0, modfuncList=None, tracePython=False, autoClearShell=True, autoContinue=True, autoFork=False, forkChild=False)

Constructor

caption
  the caption to be displayed (string)
interpreterList
  list of interpreters (list of string)
argvList
  history list of commandline arguments (list of strings)
wdList
  history list of working directories (list of strings)
envList
  history list of environment settings (list of strings)
exceptions
  exception reporting flag (boolean)
parent
  parent widget of this dialog (QWidget)
dialogType
  type of the start dialog
  - 0 = start debug dialog
  - 1 = start run dialog
  - 2 = start coverage dialog
  - 3 = start profile dialog
modfuncList=
  history list of module functions (list of strings)
tracePython=
  flag indicating if the Python library should be traced as well (boolean)
autoClearShell=
  flag indicating, that the interpreter window should be cleared automatically (boolean)
autoContinue=
  flag indicating, that the debugger should not stop at the first executable line (boolean)
autoFork=
  flag indicating the automatic fork mode (boolean)
forkChild=
  flag indicating to debug the child after forking (boolean)

#### StartDialog.__clearHistories

__clearHistories()

Private slot to clear the combo boxes lists and record a flag to clear the lists.

#### StartDialog.__editHistory

__editHistory()

Private slot to edit a history list.

#### StartDialog.clearHistories

clearHistories()

Public method to test, if histories shall be cleared.

Returns:
  flag indicating histories shall be cleared

Return Type:
  bool

#### StartDialog.getCoverageData

getCoverageData()

Public method to retrieve the coverage related data entered into this dialog.

Returns:
  flag indicating erasure of coverage info (boolean)

#### StartDialog.getData

getData()

Public method to retrieve the data entered into this dialog.

Returns:
  a tuple of interpreter (string), argv (string), workdir (string), environment (string), exceptions flag (boolean), clear interpreter flag (boolean) and run in console flag (boolean)

#### StartDialog.getDebugData

getDebugData()

Public method to retrieve the debug related data entered into this dialog.

Returns:
  a tuple of a flag indicating, if the Python library should be traced as well, a flag indicating, that the debugger should not stop at the first executable line (boolean), a flag indicating, that the debugger should fork automatically (boolean) and a flag indicating, that the debugger should debug the child process after forking automatically (boolean)

#### StartDialog.getHistories

getHistories()

Public method to get the lists of histories.

Returns:
  tuple containing the histories of command line arguments, working directories, environment settings and interpreters

Return Type:
  tuple of four list of str

#### StartDialog.getProfilingData

getProfilingData()

Public method to retrieve the profiling related data entered into this dialog.

Returns:
  flag indicating erasure of profiling info (boolean)

#### StartDialog.getRunData

getRunData()

Public method to retrieve the debug related data entered into this dialog.

Returns:
  a tuple of a flag indicating, that the debugger should fork automatically (boolean) and a flag indicating, that the debugger should debug the child process after forking automatically (boolean)

#### StartDialog.historiesModified

historiesModified()

Public method to test for modified histories.

Returns:
  flag indicating modified histories

Return Type:
  bool

#### StartDialog.on_buttonBox_clicked

on_buttonBox_clicked(button)

Private slot called by a button of the button box clicked.

button
  button that was clicked (QAbstractButton)

#### StartDialog.on_modFuncCombo_editTextChanged

on_modFuncCombo_editTextChanged()

Private slot to enable/disable the OK button.

Up